import { HttpCache } from '../http-cache.js';
import { HttpHeaders } from '../http-headers.js';
import { Http } from '../http-params.js';
import { HttpResponse } from '../http-response.js';
import '../http-client-props.js';

declare namespace HttpGet {
    type ResponseType = 'arraybuffer' | 'blob' | 'document' | 'json' | 'text' | 'stream';
    type Input = {
        timeout?: number;
        baseURL?: string;
        url: string;
        headers?: HttpHeaders;
        routeParams?: Http.Route[];
        queryParams?: Http.Query[];
        responseType?: ResponseType;
        cache?: HttpCache.Props | false;
    };
}
interface HttpGetClient {
    get<R = any>(input: HttpGet.Input): Promise<HttpResponse<R>>;
}

export { HttpGet, HttpGetClient };
